Subject: Re: [PATCH] esp: fix page frag reference leak on skb_to_sgvec failure

From: Steffen Klassert <[email-masked]>
Date: Thu, 14 May 2026 10:41:36 +0200

On Thu, May 14, 2026 at 10:11:23AM +0200, Alessandro Schino wrote:
> From: e521588 <[email-masked]>
> 
> In esp_output_tail(), when esp->inplace is false, the old skb page frags
> are replaced with a new page from the xfrm page_frag cache. The source
> scatterlist (sg) is built from the old frags before the replacement, and
> esp_ssg_unref() is responsible for releasing the old page references
> after the crypto operation completes.
> 
> However, if the second skb_to_sgvec() call (which builds the destination
> scatterlist from the new page) fails, the code jumps to error_free which
> only calls kfree(tmp). The old page frag references captured in the
> source scatterlist are never released:
> 
>   1. sg[] is built from old frags via skb_to_sgvec() (no extra get_page)
>   2. nr_frags is set to 1 and frag[0] is replaced with the new page
>   3. Second skb_to_sgvec() fails -> goto error_free
>   4. kfree(tmp) frees the sg[] memory but old frags are not unref'd
>   5. kfree_skb() only releases frag[0] (the new page), not the old ones
> 
> Fix this by calling esp_ssg_unref() before the goto error_free when the
> second skb_to_sgvec() fails. At this point, the source scatterlist in
> tmp is fully populated, so esp_ssg_unref() can properly release all old
> page frag references.
> 
> The same issue exists in both esp4 and esp6 as the code is identical.
> 
> Signed-off-by: Alessandro Schino <[email-masked]>

As this is a fix, please add a 'Fixes:' tag to the commit message.

Thanks!